#include <gsl/gsl_sf.h>
#include <gsl/gsl_math.h>
#include <gsl/gsl_errno.h>
#include <gsl/gsl_spline.h>
#include <gsl/gsl_randist.h>
#include <gsl/gsl_cdf.h>
#include <stdio.h>
#include <stddef.h>
#include <stdlib.h>
#include <CallFunc.h>
#include <Class.h>

#include <TTree.h>
#include <TH3.h>
#include <TH2.h>
#include <TH1.h>
#include <TF1.h>
#include <TVirtualX.h>

#include "general.h"

#include <TFile.h>
#include <TCutG.h>
#include <TCanvas.h>
#include <TAxis.h>
#include <TPaletteAxis.h>
#include <TRandom.h>
#include <TRandom2.h>
#include <TRandom3.h>
#include <TPaveText.h>
#include <TText.h>
#include <TStyle.h>
#include <TEllipse.h>
#include <TVector3.h>
#include <TPaveStats.h>
#include <TIterator.h>
#include <TKey.h>
#include <TString.h>
#include <string.h>
#include <TFunction.h>
#include <TLine.h>
#include <TEllipse.h>
#include <TArrow.h>
#include <TBRIK.h>
#include <TCONE.h>
#include <TTUBE.h>
#include <TNode.h>
#include <TRotMatrix.h>
#include <TView.h>

#include <TGClient.h>
#include <TCanvas.h>
#include <TF1.h>
#include <TRandom.h>
#include <TGButton.h>
#include <TGFrame.h>
#include <TRootEmbeddedCanvas.h>
#include <RQ_OBJECT.h>
#include <TQObject.h>
#include <TQConnection.h>



#include <TControlBar.h>
#include <TGMenu.h>
#include <TGTextEdit.h>
#include <TGFileDialog.h>
#include <TRootCanvas.h>	
#include <TGStatusBar.h>
#include <TApplication.h>
#include <TGProgressBar.h>
#include <TSystem.h>


#include <TGraph2DErrors.h>
#include <TGraph2D.h>
#include <TGraphAsymmErrors.h>
#include <TGraphBentErrors.h>
#include <TGraphDelaunay.h>
#include <TGraphEditor.h>
#include <TGraphErrors.h>
#include <TGraph.h>
#include <TGraphPainter.h>
#include <TGraphSmooth.h>
#include <TColor.h>                              



#include <TROOT.h>
#include <TVirtualX.h>
#include <TGResourcePool.h>
#include <TGListBox.h>
#include <TGListTree.h>
#include <TGFSContainer.h>
#include <TGClient.h>
#include <TGFrame.h>
#include <TGIcon.h>
#include <TGLabel.h>
#include <TGButton.h>
#include <TGTextEntry.h>
#include <TGNumberEntry.h>
#include <TGMsgBox.h>
#include <TGMenu.h>
#include <TGCanvas.h>
#include <TGComboBox.h>
#include <TGTab.h>
#include <TGSlider.h>
#include <TGDoubleSlider.h>
#include <TGFileDialog.h>
#include <TGTextEdit.h>
#include <TGShutter.h>
#include <TGProgressBar.h>
#include <TGColorSelect.h>
#include <TRootEmbeddedCanvas.h>
#include <TCanvas.h>
#include <TH1.h>
#include <TH2.h>
#include <TRandom.h>
#include <TSystem.h>
#include <TSystemDirectory.h>
#include <TEnv.h>
#include <TFile.h>
#include <TKey.h>
#include <TGDockableFrame.h>
#include <TGFontDialog.h>
#include <TStopwatch.h>
                             


#define r2d 180.0/M_PI
#define d2r M_PI/180.0





MyMainFrame::MyMainFrame(const TGWindow *p, UInt_t w,UInt_t h)

{

fMain	=  new TGMainFrame(p,w,h);
fEcanvas=  new TRootEmbeddedCanvas("Ecanvas",fMain,700,700);
   
gStyle->Reset();
gStyle->SetPalette(1,0);
gPad->Modified();
gPad->Update();



gStyle->SetTitleFont(42,"xy");
 gStyle->SetLabelFont(42,"xy");
 gStyle->SetLabelFont(42,"z");


 gStyle->SetFrameFillColor(0);
 gStyle->SetFrameLineWidth(2);

  gStyle->SetLineWidth(2);
  gStyle->SetTextSize(1.1);
  gStyle->SetLabelSize(0.05,"xy");
  gStyle->SetTitleSize(0.06,"xy");
  gStyle->SetTitleOffset(1.2,"x");
  gStyle->SetTitleOffset(1.0,"y");
  gStyle->SetTickLength(0.03,"x");
  gStyle->SetTickLength(0.01,"y");
  gStyle->SetNdivisions(1008,"x");
  gStyle->SetNdivisions(1008,"y");

gStyle->SetStatH(0.13);  gStyle->SetStatW(0.13); 
gPad->SetRightMargin(0.251);



Int_t wid = fEcanvas->GetCanvasWindowId();
//printf("%d\n",wid);
   TCanvas *myc = new TCanvas("MasterCanvas", 10,10,wid);
 
   myc->Range(-29.3176,-29.3123,29.9765,25.5164);

   myc->SetBorderSize(2);
  myc->SetBorderMode(0);
  myc->SetFillColor(0);;
   myc->SetLogz();
   myc->SetGridx();
   myc->SetGridy();
   myc->SetTickx();
   myc->SetTicky();

   myc->SetLeftMargin(0.157143);
 myc->SetRightMargin(0.402679);
 myc->SetBottomMargin(0.169844);
//  myc->SetFrameFillColor(0);
//  myc->SetFrameLineWidth(2);

//run_disp();

// gPad->SetRightMargin(0.251);



fEcanvas->AdoptCanvas(myc);
myc->Connect("ProcessedEvent(Int_t,Int_t,Int_t,TObject*)","MyMainFrame",this,"EventInfo(Int_t,Int_t,Int_t,TObject*)");

fMain->AddFrame(fEcanvas,new TGLayoutHints(kLHintsExpandX | kLHintsExpandY,10,10,10,1));
//fMain->AddFrame(c1,new TGLayoutHints(kLHintsExpandX | kLHintsExpandY,10,10,10,1));

fMenuDock = new TGDockableFrame(fMain);
fMain->AddFrame(fMenuDock, new TGLayoutHints(kLHintsExpandX, 0, 0, 1, 0));
fMenuDock->SetWindowName("GuiTest Menu");

fMenuBarLayout = new TGLayoutHints(kLHintsTop | kLHintsExpandX);
fMenuBarItemLayout = new TGLayoutHints(kLHintsTop | kLHintsLeft, 0, 4, 0, 0);
fMenuBarHelpLayout = new TGLayoutHints(kLHintsTop | kLHintsRight);






// status bar
   Int_t parts[] = {35, 15, 30};
   fStatusBar = new TGStatusBar(fMain, 50, 10, kVerticalFrame);
   fStatusBar->SetParts(parts, 3);
   fMain->AddFrame(fStatusBar, new TGLayoutHints(kLHintsExpandX, 0, 0, 10, 0));


TGHorizontalFrame *hframe=new TGHorizontalFrame(fMain,200,40);

/*
TGTextButton *ginput = new TGTextButton(hframe,"&Edit_Input","gROOT->ProcessLine(\".! vi input_m.dat \")");
hframe->AddFrame(ginput, new TGLayoutHints(kLHintsLeft,5,5,3,4));
*/

TGTextButton *gcut = new TGTextButton(hframe,"&Draw_A_Cut","gROOT->SetEditorMode(\"CutG\")");
//print->Connect("Clicked()","MyMainFrame",this,"p()");
hframe->AddFrame(gcut, new TGLayoutHints(kLHintsLeft,5,5,3,4));

/*
TGTextButton *draw = new TGTextButton(hframe,"&Store_A_Cut");
draw->Connect("Clicked()","MyMainFrame",this,"cutg()");
//hframe->AddFrame(draw, new TGLayoutHints(kLHintsCenterX,5,5,3,4));
hframe->AddFrame(draw, new TGLayoutHints(kLHintsCenterX,5,5,3,4));
*/

TGTextButton *gvol = new TGTextButton(hframe,"&Volume_Cut");
gvol->Connect("Clicked()","MyMainFrame",this,"gfunc0()");
hframe->AddFrame(gvol, new TGLayoutHints(kLHintsCenterX,5,5,3,4));


TGTextButton *gstat = new TGTextButton(hframe,"&Volume_1D/2D");
gstat->Connect("Clicked()","MyMainFrame",this,"statf()");
hframe->AddFrame(gstat, new TGLayoutHints(kLHintsCenterX,5,5,3,4));




TGTextButton *gprojX = new TGTextButton(hframe,"&ProjX_Cut");
gprojX->Connect("Clicked()","MyMainFrame",this,"gfunc2()");
hframe->AddFrame(gprojX, new TGLayoutHints(kLHintsCenterX,5,5,3,4));


TGTextButton *gprojY = new TGTextButton(hframe,"&ProjY_Cut");
gprojY->Connect("Clicked()","MyMainFrame",this,"gfunc3()");
hframe->AddFrame(gprojY, new TGLayoutHints(kLHintsCenterX,5,5,3,4));



TGTextButton *gdrawanygraph = new TGTextButton(hframe,"&ASCII");
gdrawanygraph->Connect("Clicked()","MyMainFrame",this,"drawanygraph()");
hframe->AddFrame(gdrawanygraph, new TGLayoutHints(kLHintsLeft,50,5,3,4));


TGTextButton *gbrow = new TGTextButton(hframe,"&Browser");
gbrow->Connect("Clicked()","MyMainFrame",this,"TheBrowserX()");
//hframe->AddFrame(draw, new TGLayoutHints(kLHintsCenterX,5,5,3,4));
hframe->AddFrame(gbrow, new TGLayoutHints(kLHintsLeft,55,55,3,4));


TGTextButton *clearallg = new TGTextButton(hframe,"&Clear_All");
clearallg->Connect("Clicked()","MyMainFrame",this,"gclearall()");
hframe->AddFrame(clearallg, new TGLayoutHints(kLHintsLeft,50,5,3,4));

TGTextButton *exit = new TGTextButton(hframe,"&Exit","gApplication->Terminate(0)");
hframe->AddFrame(exit, new TGLayoutHints(kLHintsRight,250,400,3,4));









fMain->AddFrame(hframe,new TGLayoutHints(kLHintsLeft,2,2,2,6));


fMain->SetWindowName("The Master Frame!");
fMain->MapSubwindows();
fMain->Resize(fMain->GetDefaultSize());
fMain->MapWindow();

//fClient->WaitFor(this);

}
 

MyMainFrame::~MyMainFrame()
{
	fMain->Cleanup();
	delete fMain;
}



void ReadInputX(void);
//function prototype for Rutherford cross section in the lab frame (mb/sr);
double RuthX(double Zproj,double Ztarg,double Aproj,double Atarg,double ELAB,double ThLAB);

//some global defs 

double xB_Left,xB_Right,xF_Left,xF_Right,yB_Left,yB_Right,yF_Left,yF_Right;
double thb0,phb0,thf0,phf0,db,df;
double Z1,Z2,M1,M2,Elab;
double sigmaM,sigmaTKE;

int main(int argc, char **argv)
 {

TApplication theApp("App", &argc, argv);
  //    new MyMainFrame(gClient->GetRoot(),200,200);
 if (gROOT->IsBatch()) {
      fprintf(stderr, "%s: cannot run in batch mode\n", argv[0]);
      return 1;
   }
      
	new MyMainFrame(gClient->GetRoot(),200,200);

theApp.Run();
return 0;
}



//Rutherford function

 double RuthX(double Zproj,double Ztarg,double Aproj,double Atarg,double ELAB,double ThLAB)

{
double ruthxval;
ruthxval=1.296*pow((Zproj*Ztarg/ELAB),2)*((1.0/pow(sin(0.5*ThLAB*d2r),4))-2.0*pow((Aproj/Atarg),2));
return(ruthxval);
}



void MyMainFrame::drawanygraph( void)

{



        TList  * objList = gPad->GetListOfPrimitives();
    	TIter next(objList);
    	TH1F *his1f = new TH1F();
        TH1D *his1d=new TH1D();
int dec2=0,ng=0;
double xmin=0,xmax=0,xmaxn=0;

	TObject *obV;
     

                while ( (obV = next()) ){
        	if ( obV->IsA() == TH1F::Class() )
           	{his1f = (TH1F *)obV;dec2=0;ng=his1f->GetXaxis()->GetNbins();
                xmin = his1f->GetXaxis()->GetXmin();xmax = his1f->GetXaxis()->GetXmax();
		xmaxn= his1f->GetMaximum();his1f->SetAxisRange(xmin,xmax);
		}
		else
                if ( obV->IsA() == TH1D::Class() )
             	{his1d = (TH1D *)obV;dec2=1;ng=his1d->GetXaxis()->GetNbins();
		xmin = his1d->GetXaxis()->GetXmin();xmax = his1d->GetXaxis()->GetXmax();
		xmaxn= his1d->GetMaximum();his1d->SetAxisRange(xmin,xmax);
		}
		}



FILE *graphdat;

graphdat = fopen("graph.dat", "w+t");



double xg[ng],yg[ng];


if(dec2==0)
{

//printf("%d %d\n",ny,nynew);


for( int ig=1;ig<=ng;ig++)
{
xg[ig]=his1f->GetBinCenter(ig);
yg[ig]=his1f->GetBinContent(ig);
//if(yg[ig] <= 0){continue;}
fprintf(graphdat,"%g %g\n",xg[ig],yg[ig]);
}
}
else
{
//printf("%d %d\n",ny,nynew);


for( int ig=1;ig<=ng;ig++)
{
xg[ig]=his1d->GetBinCenter(ig);
yg[ig]=his1d->GetBinContent(ig);
//if(yg[ig] <= 0){continue;}
fprintf(graphdat,"%g %g\n",xg[ig],yg[ig]);
}
}

fclose(graphdat);


TPaveText ptf14(0.85,0.4,0.98,0.595,"blNDC");
//ptf.SetTextSize(0.03);
ptf14.AddText("ASCII data saved ");
ptf14.SetTextSize(0.02);
ptf14.AddText("in \"graph.dat\"");
ptf14.SetFillColor(5);
ptf14.Draw();
//gPad->cd();
gPad->Modified();
gPad->Update();



}


void MyMainFrame::gclearall(void)

{
gROOT->ProcessLine("delete b;");
gROOT->GetListOfFiles()->Clear();
}


void MyMainFrame::TheBrowserX(void)
{
gROOT->ProcessLine("TBrowser *b = new TBrowser(\"b\",\"TheBrowser\",450,900);");

}


void MyMainFrame::volume(int mjk)


{
TCutG *cut=new TCutG();
        TList  * objList = gPad->GetListOfPrimitives();
    	TIter next(objList);
    	TH2F *mth2f = new TH2F();
double cont;
char cutregion[100];

	TObject *obV;
     
   //     TAxis *xaxis; 
    	while ( (obV = next()) ){
        	if ( obV->IsA() == TH2F::Class() )
             	{mth2f = (TH2F *)obV;strcpy(cutregion,mth2f->GetName());}
		else
		if ( obV->IsA() == TCutG::Class() )
		{cut = (TCutG *)obV;}  
}
        
//        cut = (TCutG*) gPad -> WaitPrimitive("CUTG");





  TAxis *xAxis = mth2f->GetXaxis();
  TAxis *yAxis = mth2f->GetYaxis();
  int nx = xAxis->GetNbins();
  int ny = yAxis->GetNbins();


     int firstxbin =0;
     int lastxbin = nx;
     int firstybin = 0;
     int lastybin = ny;
 




  
delete gDirectory->FindObject("VirtualXY");
//  TH2F  *VirtualXY[2];

  

//VirtualXY->(kOverwrite);





//VirtualXY->SetDirectory(0);
//  VirtualXY[jj]= new TH2F(Form("VirtualXY%d",jj),"proj XY ",nx,firstxbin,lastxbin,ny,firstybin,lastybin);





  double xmin = xAxis->GetXmin();
  double xmax = xAxis->GetXmax();
  double ymin = yAxis->GetXmin();
  double ymax = yAxis->GetXmax();

TH2F *VirtualXY= new TH2F("VirtualXY",Form("%s_Cut",cutregion),nx,xmin,xmax,ny,ymin,ymax);

VirtualXY->SetOption("COLSCATZ");
VirtualXY->SetContour(40);


//VirtualXY->SetAxisRange(xmin,xmax);



  double ConCoeffX  =  (xmax - xmin)/float(nx);
  double ConCoeffY  =  (ymax - ymin)/float(ny);

  double entries = 0;
  double py  =  ymin+ (firstybin -1.5)*ConCoeffY;
  double pxstart  =  xmin+ (firstxbin -1.5)*ConCoeffX;
//printf("%d %d\n",nx,ny);
//printf("%g %g\n",ConCoeffX,ConCoeffY);
//printf("%g %g\n",ymin,ymax);
int binx,biny;
//int inside=0;

for (biny=firstybin; biny<=lastybin; biny++)
  {
     py = py + ConCoeffY;
     double px  = pxstart;
     for (binx=firstxbin; binx<=lastxbin;binx++) {
     	
     	px = px + ConCoeffX;
	

 		cont  =mth2f->GetBinContent(binx,biny);

if( cut->IsInside(px, py)){entries += cont;VirtualXY->SetBinContent(binx,biny,cont);}
else
{continue;}



	}
	
        	
	}


double meanX_v,meanY_v,sigmaX_v,sigmaY_v;
meanX_v=VirtualXY->ProjectionX()->GetMean();
meanY_v=VirtualXY->ProjectionY()->GetMean();
sigmaX_v=VirtualXY->ProjectionX()->GetRMS();
sigmaY_v=VirtualXY->ProjectionY()->GetRMS();
//printf("%g\n",meanX_v);

gStyle->SetOptStat(1101);


if(mjk==1)
{
//getbackcanvas();

 

VirtualXY->Draw();



gPad->cd();
gPad->Update();

}
else
if(mjk==2)
{



//TCanvas *fCanvas = fEcanvas->GetCanvas();
delete gDirectory->FindObject("VirtualXY_px");
gStyle->SetErrorX(0);

TH1D *VirtualXY_px = new TH1D();
VirtualXY_px = VirtualXY->ProjectionX();

/*
VirtualXY_px->SetOption("E1");
VirtualXY_px->SetFillColor(1);
VirtualXY_px->SetMarkerStyle(21);
VirtualXY_px->SetMarkerSize(0.8);
*/
VirtualXY_px->Draw();


gPad->cd();
gPad->Update();

}
else
if(mjk==3)
{

//TCanvas *fCanvas = fEcanvas->GetCanvas();
 
delete gDirectory->FindObject("VirtualXY_py");
gStyle->SetErrorX(0);

TH1D *VirtualXY_py = new TH1D();
VirtualXY_py = VirtualXY->ProjectionY();

/*
//VirtualXY_py->SetOption("E1");
VirtualXY_py->SetFillColor(1);
VirtualXY_py->SetMarkerStyle(21);
VirtualXY_py->SetMarkerSize(0.8);
*/
VirtualXY_py->Draw();



gPad->cd();
gPad->Update();

}
else
if(mjk==4)

{

cut->Draw();

TCanvas *fCanvas = fEcanvas->GetCanvas();
fCanvas->cd();
fCanvas->Update();
}
else
if(mjk==5)

{
cut->Delete();
gPad->cd();
gPad->Update();
}
else
if(mjk==0)

{
TCanvas *fCanvas = fEcanvas->GetCanvas();


TPaveText pt(0.85,0.4,0.98,0.595,"blNDC");
//pt.SetNDC();
//pt.SetLabel("The System");

pt.AddText("In the gated region:");
pt.AddText(Form("Volume=%g\n",entries));
pt.AddText(Form("X-Mean=%g\n",meanX_v));
//pt.AddText(Form("#sigma_{X}=%g\n",sigmaX_v));
pt.AddText(Form("Y-Mean=%g\n",meanY_v));
//pt.AddText(Form("#sigma_{Y}=%g\n",sigmaY_v));
//t1.SetTextColor(2);
//pt.AddText(Form("VirtualXY%d",10));
pt.SetFillColor(5);
pt.Draw();


fCanvas->cd();
fCanvas->Update();

}


//{printf("Volume=%d\n",entries);}
//else



    }
 




//Function for area and mean


void MyMainFrame::statf(void)

{
 
gStyle->SetOptStat(1); 

TCanvas *fCanvas = fEcanvas->GetCanvas();


TPaveText pt(0.85,0.4,0.98,0.595,"blNDC");




        TList  * objList = gPad->GetListOfPrimitives();
    	TIter next(objList);

         TObject *obV;
     TH1F *fth1f = new TH1F();
     TH1D *fth1d = new TH1D();
     TH2F *fth2f = new TH2F();
int yon=0;     

 	while ( (obV = next()) )
        	if ( obV->IsA() == TH1F::Class() )
           	{fth1f = (TH1F *)obV;yon=1;}
		else
                if ( obV->IsA() == TH2F::Class() )
		{fth2f = (TH2F *)obV;yon=2;}
                else
                if ( obV->IsA() == TH1D::Class() )
             	{fth1d = (TH1D *)obV;yon=3;}


//printf("%d\n",yon);


int nx=0,ny=0,vol=0;

if(yon==1)
{




  TAxis *xAxis = fth1f->GetXaxis();
  nx = xAxis->GetNbins();
  vol=int(fth1f->Integral());
double mean1;
 mean1= fth1f->GetMean(); 



pt.AddText(Form("Area = %d\n",vol));
pt.AddText(Form("Mean = %g\n",mean1));


}
else
if(yon==2)
{
  TAxis *xAxis = fth2f->GetXaxis();
  TAxis *yAxis = fth2f->GetYaxis();
  nx = xAxis->GetNbins();
  ny = yAxis->GetNbins();
  vol= int(fth2f->Integral());
//printf("Area = %d\n",vol);


pt.AddText(Form("Area = %d\n",vol));

}
else
if(yon==3)
{
  TAxis *xAxis = fth1d->GetXaxis();
  nx = xAxis->GetNbins();

vol=int(fth1d->Integral());
double mean1;
 mean1= fth1d->GetMean(); 
//printf("Area = %d Mean = %g\n",vol,mean1);

pt.AddText(Form("Area = %d\n",vol));
pt.AddText(Form("Mean = %g\n",mean1));

}
pt.SetFillColor(5);
pt.Draw();


fCanvas->cd();
fCanvas->Update();

    }
 

void MyMainFrame::gfunc0(void)
{

//printf("x\n");
volume(0);
}

void MyMainFrame::gfunc1(void)
{
volume(1);
}
//void pp3(int klm)
void MyMainFrame::gfunc2(void)
{
volume(2);
}

void MyMainFrame::gfunc3(void)
{
volume(3);
}

void MyMainFrame::gfunc4(void)
{
volume(4);
}

void MyMainFrame::gfunc5(void)
{
volume(5);
}

































void MyMainFrame::SetStatusText(const char *txt, Int_t pi)
{
   // Set text in status bar.
   fStatusBar->SetText(txt,pi);
}


void MyMainFrame::EventInfo(Int_t event, Int_t px, Int_t py, TObject *selected)
{
//  Writes the event status in the status bar parts

    //Printf("Slot EventInfo()");

 //   TCanvas *c = (TCanvas *) gTQSender;
   
   const char *text0, *text1, *text3;
   char text2[50];
   text0 = selected->GetTitle();
   SetStatusText(text0,0);
   text1 = selected->GetName();
   SetStatusText(text1,1);

   if (event == kKeyPress)
      sprintf(text2, "%c", (char) px);
   else
      sprintf(text2, "%d,%d", px, py);
//   SetStatusText(text2,2);
   text3 = selected->GetObjectInfo(px,py);
   SetStatusText(text3,2);
}



void ReadInputX(void)

{



FILE *finput;


finput = fopen("input_m.dat", "r+t");


fscanf(finput,"%lf %lf %lf %lf",&xB_Left,&xB_Right,&xF_Left,&xF_Right);
fscanf(finput,"%lf %lf %lf %lf",&yB_Left,&yB_Right,&yF_Left,&yF_Right);
fscanf(finput,"%lf %lf %lf %lf %lf %lf",&thf0,&phf0,&thb0,&phb0,&df,&db);
fscanf(finput,"%lf %lf %lf %lf %lf", &Z1,&Z2,&M1,&M2,&Elab);
fscanf(finput,"%lf %lf",&sigmaM,&sigmaTKE);


fclose(finput);


}





